searchData={"items":[{"type":"module","title":"Cloister","doc":"`Cloister` is a consensus helper for clusters.\n\nIt is designed to be a configurable drop-in for transparent cluster support.\n\n#","ref":"Cloister.html"},{"type":"module","title":"Supported options - Cloister","doc":"* `:otp_app` (`t:atom/0`) - OTP application this cloister runs for. The default value is `:cloister`.\n\n* `:sentry` - Required. The way the cloister knows how to build cluster; might be a service name or a node list.\n  E. g. `:\"cloister.local\"` or `~w[c1@127.0.0.1 c2@127.0.0.1]a`. Default `[node()]`.\n\n* `:consensus` (`t:non_neg_integer/0`) - Required. Number of nodes to consider consensus. The default value is `1`.\n\n* `:listener` (`t:atom/0`) - Listener to be called when the ring is changed. The default value is `Cloister.Listener.Default`.\n\n* `:additional_modules` - Additional modules to include into `Cloister.Manager`’s supervision tree.\n\n* `:ring` (`t:atom/0`) - The name of the `HashRing` to be used.\n  If set, the _HashRing_ is assumed to be managed externally.\n\n* `:manager` (non-empty `t:keyword/0`) - Set of options to configure `Cloister.Manager` when started in a supervision tree.\n\n  * `:name` (`t:atom/0`) - Name of the `Manager` process.\n\n  * `:state` (non-empty `t:keyword/0`) - The parameters to configure the `Manager` ouside of `Cloister` application.\n\n    * `:otp_app` (`t:atom/0`) - Required.\n\n    * `:additional_modules`\n\n* `:monitor_opts` (non-empty `t:keyword/0`) - Fine `Cloister.Monitor`’s tuning.\n\n  * `:name` (`t:atom/0`) - Required. Name of the `Monitor` process.\n\n* `:loopback?` (`t:boolean/0`) - Use loopback interface in FQ node name? The default value is `false`.\n\n* `:magic?` - When false, allows to avoid node reinitialization The default value is `:longnames`.","ref":"Cloister.html#module-supported-options"},{"type":"function","title":"Cloister.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cloister.html#child_spec/1"},{"type":"function","title":"Cloister.mine?/1","doc":"Returns `true` if the hashring points to this node for the term given, `false` otherwise","ref":"Cloister.html#mine?/1"},{"type":"function","title":"Cloister.multiapply/4","doc":"Applies the function given as `m, f, a` on all the nodes given as a first parameter.\n\nIf no `nodes` are given, it defaults to `Cloister.siblings/0`.","ref":"Cloister.html#multiapply/4"},{"type":"function","title":"Cloister.multicall/2","doc":"","ref":"Cloister.html#multicall/2"},{"type":"function","title":"Cloister.multicall/3","doc":"","ref":"Cloister.html#multicall/3"},{"type":"function","title":"Cloister.multicast/2","doc":"","ref":"Cloister.html#multicast/2"},{"type":"function","title":"Cloister.multicast/3","doc":"","ref":"Cloister.html#multicast/3"},{"type":"function","title":"Cloister.ring/0","doc":"Returns the `ring` from current node cloister monitor state","ref":"Cloister.html#ring/0"},{"type":"function","title":"Cloister.siblings/0","doc":"","ref":"Cloister.html#siblings/0"},{"type":"function","title":"Cloister.siblings!/0","doc":"","ref":"Cloister.html#siblings!/0"},{"type":"function","title":"Cloister.state/0","doc":"","ref":"Cloister.html#state/0"},{"type":"function","title":"Cloister.whois/2","doc":"Returns who would be chosen by a hash ring for the term in the group given","ref":"Cloister.html#whois/2"},{"type":"behaviour","title":"Cloister.Listener","doc":"The behavior to be implemented by `Cloister.Monitor` listeners.","ref":"Cloister.Listener.html"},{"type":"callback","title":"Cloister.Listener.on_state_change/2","doc":"Passed to the `Cloister.Monitor.start_link/1` and is being called\non each subsequent monitored node state change.\n\nListeners are obliged to handle `:up`, `:rehashing` and `:stopping` events.","ref":"Cloister.Listener.html#c:on_state_change/2"},{"type":"module","title":"Cloister.Manager","doc":"Use this module to start _Cloister_ manually inside the application\nsupervision tree instead of running it as an application (default.)\n\nThis is not recommended and requires better understanding of internals.\nAlso, `:cloister` must be put into `:included_applications` section\nof your application `mix.exs` to prevent the application from starting up\nduring the dependent applications starting phase.","ref":"Cloister.Manager.html"},{"type":"function","title":"Cloister.Manager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cloister.Manager.html#child_spec/1"},{"type":"function","title":"Cloister.Manager.start_link/1","doc":"Starts the cloister manager process in the supervision tree","ref":"Cloister.Manager.html#start_link/1"},{"type":"module","title":"Cloister.Monitor","doc":"The actual process that performs the monitoring of the cluster and invokes callbacks.\n\nThis process is started and supervised by `Cloister.Manager`.","ref":"Cloister.Monitor.html"},{"type":"function","title":"Cloister.Monitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cloister.Monitor.html#child_spec/1"},{"type":"function","title":"Cloister.Monitor.nodes!/1","doc":"Rehashes the ring and returns the current state","ref":"Cloister.Monitor.html#nodes!/1"},{"type":"function","title":"Cloister.Monitor.siblings/1","doc":"Returns the nodes in the cluster that are connected to this one in the same group","ref":"Cloister.Monitor.html#siblings/1"},{"type":"function","title":"Cloister.Monitor.start_link/1","doc":"Used to start `Cloister.Monitor`.\n\nInternally called by `Cloister.Manager.start_link/1`. In most cases\n  you don’t need to start `Monitor` process explicitly.","ref":"Cloister.Monitor.html#start_link/1"},{"type":"function","title":"Cloister.Monitor.state/3","doc":"Returns an internal state of the Node","ref":"Cloister.Monitor.html#state/3"},{"type":"type","title":"Cloister.Monitor.monitor/0","doc":"Monitor state","ref":"Cloister.Monitor.html#t:monitor/0"},{"type":"type","title":"Cloister.Monitor.node_type/0","doc":"Type of the node as it has been started","ref":"Cloister.Monitor.html#t:node_type/0"},{"type":"type","title":"Cloister.Monitor.t/0","doc":"The monitor internal state","ref":"Cloister.Monitor.html#t:t/0"},{"type":"module","title":"Cloister.Monitor.Fsm","doc":"The instance of _FSM_ backed up by `Finitomata`.","ref":"Cloister.Monitor.Fsm.html"},{"type":"module","title":"FSM representation - Cloister.Monitor.Fsm","doc":"```mermaid\ngraph TD\n    down --> |quorum!| assembling\n    assembling --> |assembled| rehashing\n    rehashing --> |nonode| nonode\n    rehashing --> |rehash| rehashing\n    rehashing --> |rehash| ready\n    rehashing --> |stop!| stopping\n    ready --> |nonode| nonode\n    ready --> |rehash| ready\n    ready --> |rehash| rehashing\n    ready --> |stop!| stopping\n    nonode --> |rehash| assembling\n    stopping --> |stop!| stopped\n```","ref":"Cloister.Monitor.Fsm.html#module-fsm-representation"},{"type":"function","title":"Cloister.Monitor.Fsm.__config__/1","doc":"Getter for the internal compiled in _FSM_ information.","ref":"Cloister.Monitor.Fsm.html#__config__/1"},{"type":"function","title":"Cloister.Monitor.Fsm.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cloister.Monitor.Fsm.html#child_spec/1"},{"type":"macro","title":"Cloister.Monitor.Fsm.config/1","doc":"The convenient macro to allow using states in guards, returns a compile-time\n  list of states for `Cloister.Monitor.Fsm`.","ref":"Cloister.Monitor.Fsm.html#config/1"},{"type":"function","title":"Cloister.Monitor.Fsm.start_link/1","doc":"Starts an _FSM_ alone with `name` and `payload` given.\n\nUsually one does not want to call this directly, the most common way would be\nto start a `Finitomata` supervision tree or even better embed it into\nthe existing supervision tree _and_ start _FSM_ with `Finitomata.start_fsm/3`\npassing `Cloister.Monitor.Fsm` as the first parameter.","ref":"Cloister.Monitor.Fsm.html#start_link/1"},{"type":"type","title":"Cloister.Monitor.Fsm.state/0","doc":"Kind of event which might be send to initiate the transition.","ref":"Cloister.Monitor.Fsm.html#t:state/0"},{"type":"type","title":"FSM representation - Cloister.Monitor.Fsm.state/0","doc":"```mermaid\ngraph TD\n    down --> |quorum!| assembling\n    assembling --> |assembled| rehashing\n    rehashing --> |nonode| nonode\n    rehashing --> |rehash| rehashing\n    rehashing --> |rehash| ready\n    rehashing --> |stop!| stopping\n    ready --> |nonode| nonode\n    ready --> |rehash| ready\n    ready --> |rehash| rehashing\n    ready --> |stop!| stopping\n    nonode --> |rehash| assembling\n    stopping --> |stop!| stopped\n```","ref":"Cloister.Monitor.Fsm.html#t:state/0-fsm-representation"},{"type":"module","title":"Cloister.Node","doc":"The abstraction level allowing milticalls and multicasts across the whole cluster.","ref":"Cloister.Node.html"},{"type":"function","title":"Cloister.Node.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cloister.Node.html#child_spec/1"},{"type":"function","title":"Cloister.Node.multicall/3","doc":"Casts the request to all the nodes passed as a parameter.","ref":"Cloister.Node.html#multicall/3"},{"type":"function","title":"Cloister.Node.multicast/3","doc":"Casts the request to all the nodes connected to this node","ref":"Cloister.Node.html#multicast/3"},{"type":"task","title":"mix cloister.init","doc":"Mix task to create the dedicated environment for Cloister.","ref":"Mix.Tasks.Cloister.Init.html"},{"type":"task","title":"mix cloister.run","doc":"Mix task to run test in previously started Cloister env.","ref":"Mix.Tasks.Cloister.Run.html"},{"type":"task","title":"mix cloister.test","doc":"Mix task to run test in previously started Cloister env.","ref":"Mix.Tasks.Cloister.Test.html"},{"type":"extras","title":"Cloister","doc":"# Cloister    [![Kantox ❤ OSS](https://img.shields.io/badge/❤-kantox_oss-informational.svg)](https://kantox.com/)  ![Test](https://github.com/am-kantox/cloister/workflows/Test/badge.svg)  ![Dialyzer](https://github.com/am-kantox/cloister/workflows/Dialyzer/badge.svg)\n\n**The helper application to manage cluster of nodes.**","ref":"readme.html"},{"type":"extras","title":"Installation - Cloister","doc":"- Add the dependency to your `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:cloister, \"~> 0.5\"},\n    ...\n  ]\nend\n```\n\n- Make sure both `:cloister` and `:libring` applications are configured properly in your `config.exs`\n\n```elixir\nconfig :cloister,\n  sentry: ~w|node1@127.0.0.1 node2@127.0.0.1|a,\n  consensus: 2\n```\n\n- Make sure `:cloister` application is started. This does not require any action unless you have the list of applications specified explicitly. If so, add `:cloister` there.","ref":"readme.html#installation"},{"type":"extras","title":"Changelog - Cloister","doc":"- **`0.17.0`** [TST] shortnames, proper testing with `enfiladex`\n- **`0.16.0`** [EXP] experimental `mix` tasks to test/run stuff in a cloister\n- **`0.15.0`** [BUG] fixed `Cloister.multicast/multicall`\n- **`0.14.0`** named isolated `Finitomata` supervision tree\n- **`0.13.0`** [BUG] fixed `Cloister.state/0` adding groups (credits: @anthony-gonzalez-kantox)\n- **`0.12.0`** complete rewrite of cluster assembly based on `Finitomata`\n- **`0.10.0`** `Cloister.siblings!/0` and `Cloister.consensus/0`, better tests\n- **`0.9.0`** `Cloister.multiapply/4` to wrap `:rpc.multicall/4`\n- **`0.7.0`** `magic? :: boolean()` and `loopback? :: boolean()` config params to avoid cluster building in tests\n- **`0.6.0`** support many hashrings within the same cloister\n- **`0.2.0`** use `Application.c:start_phase/3` callback to postpone application start until the consensus is reached\n\n---\n\n## [Documentation](https://hexdocs.pm/cloister).","ref":"readme.html#changelog"},{"type":"extras","title":"Configuration","doc":"# Configuration\n\n_Cloister_ is another cluster support library that aims to be a drop-in for cluster support in distributed environment.\n\nIt relies mainly on configuration because it’s started as a separate application _before_ the main _OTP_ application that uses it and relies on startup phases to block until the consensus is reached. For the very fine tuning, one might put `:cloister` into `:included_applications` _and_ embed `Cloister.Manager` manually into the supervision tree. See `Cloister.Application.start_phase/3` for the inspiration on how to wait till consensus is reached.\n\nOn a bird view, the config might look like:\n\n```elixir\nconfig :cloister,\n  # OTP application this cloister runs for\n  otp_app: :my_app,                    # default: :cloister\n\n  # the way the cloister knows how to build cluster\n  sentry: :\"cloister.local\",           # service name\n  # or node list (default `[node()]`)\n  # sentry: ~w[c1@127.0.0.1 c2@127.0.0.1]a\n\n  # number of nodes to consider consensus\n  consensus: 3,                        # default\n\n  # listener to be called when the ring is changed\n  listener: MyApp.Listener,            # default: Stub\n\n  # monitor to handle ring changes / don’t override\n  monitor: MyApp.Monitor,              # default: Stub\n\n  # monitor options to pass to a monitor when created\n  monitor_opts: [\n    name: MyMonitor                    # default: monitor.name\n  ]\n\n  # additional modules to include into `Manager`’s supervision tree\n  additional_modules: [Cloister.Void], # useful for tests / dev\n\n  # the name of the `HashRing` to be used\n  # if set, the _HashRing_ is assumed to be managed externally\n  ring: :cloister,                     # default\n\n  # manager configuration, used when cloister app is not started\n  manager: [\n    name: Cloister.Manager,            # default\n    state: [\n      otp_app: :my_app,                # default: :cloister\n      additional_modules: []           # additional modules as above\n    ]\n  ]\n```","ref":"configuration.html"},{"type":"extras","title":"Docker Friendly","doc":"# Docker Friendly\n\n_Cloister_ is being developed with the drop-in support of [_Docker_](https://www.docker.com/). Distributed _Erlang_ is a charm to work with unless your _DevOps_ team is engaged in containerizing the whole universe. They usually have many cryptic arguments full of words you as an old-school software engineer would barely understand, and sooner or later you are faced with a fact that now we run everything in a dockerized environment, which means no one can guarantee your application has an IP/DNS, or would not have automatically restarted depending on the current moon phase.\n\nI am exaggerating a bit, but this is it: you cannot prepare the release hardcoding longnames in `vm.args` and/or `env.sh` anymore. You should be ready to handle spontaneous restarts of containers (and therefore your _ErlangVM_ instances) gracefully. And you are probably still in a need to test it locally, as well as in containerized environment.\n\nThat is where `cloister` might step into to help. It takes care about the cluster handling, based on either the list of node names (IP/DNS, old school,) or a service name exposed by docker. It uses [`Application.start_phase/3`](https://hexdocs.pm/elixir/Application.html?#c:start_phase/3) to ensure the cluster is started _before_ letting the boot process to continue. It also provides a callback when the topology of the cluster changes (new node added, node shut down, etc.)","ref":"docker-friendly.html"},{"type":"extras","title":"Dev Environment, no Docker - Docker Friendly","doc":"All one needs to start playing with `cloister` is to add a dependency to `mix.exs` file and put some config:\n\n```elixir\nconfig :cloister,\n  otp_app: :cloister_test,\n  sentry: ~w|node1@127.0.0.1 node2@127.0.0.1|a,\n  consensus: 1\n```\n\nThat config would instruct _Cloister_ to use `:cloister_test` as the main _OTP_ app _and_ the name of the [`HashRing`](https://github.com/bitwalker/libring) behind. It would expect nodes `:\"node1@127.0.0.1\"` and `:\"node2@127.0.0.1\"` to exist and it’ll try to connect to them, but as soon as it sees itself, and `consensus` parameter is set to `1`, it won’t worry about others and report the successful cluster assembly.\n\n![:nonode@nohost startup](assets/cloister-nonode-startup.png)\n\n---","ref":"docker-friendly.html#dev-environment-no-docker"},{"type":"extras","title":"Test Environment, no Docker - Docker Friendly","doc":"To test the distributed environment outside of _Docker_, one might use [`test_cluster_task`](https://github.com/am-kantox/test_cluster_task) package that effectively starts the distributed environment before running tests. To use it, simply add `{:test_cluster_task, \"~> 0.3\"}` to the dependencies list of your application and use `mix test.cluster` _or_ set the alias in `mix.exs` project:\n\n```elixir\ndef project do\n  [\n    ...,\n    aliases: [test: [\"test.cluster\"]]\n  ]\nend\n```\n\n![:\"cloister_test_0@127.0.0.1\" startup](assets/cloister-test-startup.png)\n\n---","ref":"docker-friendly.html#test-environment-no-docker"},{"type":"extras","title":"Releases for Docker Environment - Docker Friendly","doc":"OK, now it’s time to add _Docker_ to the equation. _Cloister_ is smart enough to distinguish the list of node vs. the service name when passed to `:sentry` config option. When it’s an atom, _Cloister_ will shut down the `:net_kernel` application and restart it in distributed mode. For that to work, one must explicitly specify `export RELEASE_DISTRIBUTION=none` in `rel/env.sh.eex` file for releases.\n\nOur config would now look like:\n\n```elixir\nconfig :cloister,\n  otp_app: :cloister_test,\n  sentry: :\"cloister_test.local\",\n  consensus: 3\n```\n\nHere, `:\"cloister_test.local\"` is the name of service to be used for nodes discovery _and_ at least three nodes up would be expected for it to pass the _warming_ phase. The application startup chain would be blocked until at least three nodes are up and connected.\n\nWe would also need a `Dockerfile` which is the typical one, built from `elixir:$ELIXIR_VERSION` and with `epmd -d` _explicitly started_ before the application itself. Also we’d need `docker-compose.yml`, declaring the service like below.\n\n```yaml\nversion: '3.1'\n\nservices:\n  cloister_test:\n    build: .\n    networks:\n      local:\n        aliases:\n          - cloister_test.local\n    environment:\n      - CLOISTER_TEST_CLUSTER_ADDRESS=cloister_test.local\n\nnetworks:\n  local:\n    driver: bridge\n```\n\nOnce done, one might build the composed image and start it with three instances of the application:\n\n```sh\ndocker-compose build\ndocker-compose up --scale cloister_test=3 --remove-orphans\n```\n\nAfter some debug info, it’d spit out:\n\n![:\"cloister_test@172.26.0.*\" startup](assets/cloister-docker-startup.png)\n\nAll three instances are up and connected, ready to perform their work.\n\n---","ref":"docker-friendly.html#releases-for-docker-environment"},{"type":"extras","title":"Tips and Tweaks - Docker Friendly","doc":"_Cloister_ relies mainly on configuration because it’s started as a separate application _before_ the main _OTP_ application that uses it and relies on startup phases to block until the consensus is reached. For the very fine tuning, one might put `:cloister` into `:included_applications` _and_ embed `Cloister.Manager` manually into the supervision tree. See `Cloister.Application.start_phase/3` for the inspiration on how to wait till consensus is reached.\n\nAlso, one might start and manage `HashRing` on their own by setting `:ring` option in `config`. _Cloister_ would expect the ring to be started and handled by the consumer application.\n\nThe whole configuration is described on [_Configuration_](configuration.html) page.","ref":"docker-friendly.html#tips-and-tweaks"},{"type":"extras","title":"Zero Cost Distribution","doc":"# Zero Cost Distribution\n\n_Cloister_ provides a callback on cluster topology changes, which makes it easy to perform some additional setup when the cluster is up.\n\nBut what if we want to distribute our processing without actually writing the support for running in distributed mode? For that one might use [`Tarearbol.DynamicManager`](https://hexdocs.pm/tarearbol/dynamic_workers_management.html) abstraction.\n\nLet’s say we receive gazillions of messages from some message broker and need to process them asynchronously. The typical application would use _Cloister_ as the cluster manager _and_ `Tarearbol.DynamicManager` as the workload processor. Our goal would be to build absolutely transparent system, allowing horizontal scaling out of the box. We cannot just spawn another node in a hope that everything would be fine because the processor is determined by a [`HashRing`](https://github.com/bitwalker/libring) backed up by _Cloister_ and the message would be fed from the message broker by the random—currently available—node. Of course we might ask _Cloister_ about who is to process this message, and send the message directly to this process, but this would potentially suffer from back pressure issues either blocking the broker queue, or overflowing the target process mailbox.\n\nThe easiest solution would be to store incoming messages in local store, that would be consumed by our workers. The dataflow would look somewhat like \n\n![Cloister + Tarearbol Data Flow](assets/cloister-tarearbol-data-flow.png)\n\n---\n\nThat would be a no-brainer at all, if we were working in legacy running instances. But here we have a dockerized environment. Containers might appear, and disappear almost at random. And we want to handle each topology change gracefully.","ref":"zero-cost-distribution.html"},{"type":"extras","title":"Topology Change Listener - Zero Cost Distribution","doc":"First of all, we need to supply our own inmplementation of topology change listener, as described in [_Configuration_](configuration.html).\n\n```elixir\nconfig :cloister,\n  otp_app: :my_app,\n  listener: MyApp.CloisterListener,\n  ...\n```\n\nAnd the boilerplate for the implementation would be that\n\n```elixir\ndefmodule MyApp.CloisterListener do\n  @moduledoc false\n\n  @behaviour Cloister.Listener\n  require Logger\n\n  @impl Cloister.Listener\n  def on_state_change(_from, %Cloister.Monitor{status: :up}) do\n    Logger.info(\"Cluster is up\")\n  end\n\n  def on_state_change(from, %Cloister.Monitor{status: status}) do\n    Logger.debug(\"Cluster state change #{from} → #{status}\")\n  end\n```\n\nSo far, so good. Now we want to support distributed `mnesia` here. Let’s suppose we might survive several seconds blackout on topology changes, and we use this `mnesia` as a cache, so it does not contain billions of records. We would simply load the existing cache content into memory, recreate `mnesia` for new topology and feed it with the data from memory. There are many more elegant and robust solutions, but for our demonstration purposes that scenario is perfectly fine.\n\nLet’s change the former `on_state_change/2` clause to do that.\n\n```elixir\n@impl Cloister.Listener\ndef on_state_change(_from, %Cloister.Monitor{status: :up}) do\n  this = node()\n  others = Node.list()\n  nodes = [this | others]\n\n  # voluntarily select a master node\n  if match?([^this | _], Enum.sort(nodes)) do\n    load_data_into_memory() # the implementation is out of scope\n\n    Enum.each(@tables, :mnesia.delete_table/1)\n\n    :mnesia.stop()\n    :mnesia.delete_schema(nodes)\n    :mnesia.create_schema(nodes)\n    :mnesia.start()\n\n    Enum.each(@tables, &:mnesia.create_table(&1, disk: nodes))\n    :mnesia.wait_for_tables(@tables)\n    \n    load_data_from_memory() # the implementation is out of scope\n\n    # deploy this to other nodes\n    unless nodes == [this] do\n      :mnesia.change_config(:extra_db_nodes, others)\n      Enum.each(others, &:mnesia.change_table_copy_type(:schema, &1, :disc_copies))\n\n      for table <- :mnesia.system_info(:tables),\n          table in @tables,\n          {^this, type} <- :mnesia.table_info(table, :where_to_commit),\n          do: Enum.each(others, &:mnesia.add_table_copy(table, &1, type))\n    end\n  end\nend\n```\n\nWe are done! Now the topology change would enforce the renewal of `mnesia` configuration. It surely might be done in more sophisticated way by e. g. deleting schemas on remote nodes and restarting `mnesia` there, but this is also good enough.\n\nOK, it’s now time to serve processors.","ref":"zero-cost-distribution.html#topology-change-listener"},{"type":"extras","title":"DynamicManager Implementation - Zero Cost Distribution","doc":"As described in the documentation, [`Tarearbol.DynamicManager`](https://hexdocs.pm/tarearbol/dynamic_workers_management.html) expects a worker definition. Let’s provide it.\n\n```elixir\ndefmodule MyApp.WorkProcessor do\n  @moduledoc false\n\n  use Tarearbol.DynamicManager\n\n  @impl Tarearbol.DynamicManager\n  def children_specs do\n    # start million processes, handling entities named like \"foo_42\"\n    for i <- 1..1_000_000, do: {\"foo_#{i}\", []}, into: %{}\n  end\n\n  @impl Tarearbol.DynamicManager\n  def perform(foo, payload) do\n    if Cloister.mine?(foo),\n      do: {:replace, foo, perform_work()},\n      else: {:ok, DateTime.utc_now()}\n  end\n\n  @impl Tarearbol.DynamicManager\n  def handle_state_change(state), do: state\n\n  @impl Tarearbol.DynamicManager\n  def handle_timeout(_state), do: :ok\n\n  @spec perform_work :: [any()]\n  defp perform_work do\n    for record <- :mnesia.select(...), do: ...\n  end\nend\n```\n\nWe are all set now. Once came from the broker, the message gets stored in `mnesia`. Then the worker for this _key_ gets the message(es) from there _and_ does whatever it needs.\n\nWhen the new node is being added/removed, _Cloister_ would change the state into `:rehashing`, rebuild the `mnesia` database _and_ continue processing messages with a new cluster topology.","ref":"zero-cost-distribution.html#dynamicmanager-implementation"}],"content_type":"text/markdown"}